"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _atpSugar = require("atp-sugar");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Config = function () {
    function Config() {
        _classCallCheck(this, Config);

        this.defaults = {};
        this.values = {};
        this.finalValues = {};
    }

    _createClass(Config, [{
        key: "setDefaults",
        value: function setDefaults(values) {
            this.defaults = (0, _atpSugar.o)(this.defaults).merge(values).raw;
            this.finalValues = (0, _atpSugar.o)(this.defaults).merge(this.values).raw;
        }
    }, {
        key: "setValues",
        value: function setValues(values) {
            this.values = (0, _atpSugar.o)(this.values).merge(values).raw;
            this.finalValues = (0, _atpSugar.o)(this.defaults).merge(this.values).raw;
        }
    }, {
        key: "get",
        value: function get(path) {
            try {
                return this._get(path, this.finalValues);
            } catch (e) {
                throw e + " while trying to fetch config path " + path;
            }
        }
    }, {
        key: "isset",
        value: function isset(path) {
            try {
                var temp = this.get(path);
                return true;
            } catch (e) {
                return false;
            }
        }
    }, {
        key: "_get",
        value: function _get(path, values) {
            if (path.length === 0) {
                return values;
            }

            var pathParts = path.split(".");
            var node = pathParts.shift();

            if (typeof values[node] === 'undefined') {
                throw "Missing config value " + node;
            }

            return this._get(pathParts.join("."), values[node]);
        }
    }]);

    return Config;
}();

var config = new Config();
exports.default = config;